
"""
    Access Control API

    One Ring to rule them all, One ring to find them; One ring to integrate them all and in a short time, generate a lot of money 🤑.

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from datetime import datetime
from typing import Annotated, Any, ClassVar, Self

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr


class PatchedVisitor(BaseModel):
    """
    Serializer for Visitor model.
    """ # noqa: E501
    id: StrictInt | None = None
    email: StrictStr | None = None
    created_at: datetime | None = None
    updated_at: datetime | None = None
    first_name: Annotated[str, Field(strict=True, max_length=255)] | None = Field(default=None, description="First name of the visitor.")
    last_name: Annotated[str, Field(strict=True, max_length=255)] | None = Field(default=None, description="Last name of the visitor.")
    provider_config: StrictStr | None = Field(default=None, description="The provider configuration for the visitor.")
    __properties: ClassVar[list[str]] = ["id", "email", "created_at", "updated_at", "first_name", "last_name", "provider_config"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self | None:
        """Create an instance of PatchedVisitor from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: set[str] = set([
            "id",
            "created_at",
            "updated_at",
            "provider_config",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: dict[str, Any] | None) -> Self | None:
        """Create an instance of PatchedVisitor from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "email": obj.get("email"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at"),
            "first_name": obj.get("first_name"),
            "last_name": obj.get("last_name"),
            "provider_config": obj.get("provider_config")
        })
        return _obj


